/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package test_mp3;

import javax.sound.sampled.*;
import java.io.*;


public class SimpleSoundPlayer {
    
     private AudioFormat format;
    private byte[] samples;
    
   
    public SimpleSoundPlayer(String aFilename)
    {
        try
        {
            AudioInputStream stream = AudioSystem.getAudioInputStream( new File(aFilename));
            format = stream.getFormat();
            samples = getSamples(stream);
        }
        catch(UnsupportedAudioFileException ex)
        {
            ex.printStackTrace();
        }
        catch( IOException ex)
        {
            ex.printStackTrace();
        }
    }

    public byte[] getSamples() {
        return samples;
    }

    public byte[] getSamples(AudioInputStream audioStream) {
        int lenght = (int) (audioStream.getFrameLength() * format.getFrameSize());
        byte[] samples = new byte[lenght];
        DataInputStream is = new DataInputStream(audioStream);
        try
        {
            is.readFully(samples);
        }
        catch(IOException e)
        {
            e.printStackTrace();
        }
        return samples;
        
    }
    
    public void play(InputStream source)
    {
        int bufferSize = format.getFrameSize() * Math.round(format.getSampleRate() / 10);
        byte[] buffer = new byte[bufferSize];
        SourceDataLine line;
        try
        {
            DataLine.Info info = new DataLine.Info(SourceDataLine.class,format);
            line = (SourceDataLine)AudioSystem.getLine(info);
            line.open(format,bufferSize);
        }
        catch( LineUnavailableException e )
        {
            e.printStackTrace();
            return;
        }
        line.start();
        try
        {
            int numBytesRead = 0;
            while(numBytesRead != -1)
            {
                numBytesRead = source.read(buffer,0,buffer.length);
                if(numBytesRead != -1)
                {
                    line.write(buffer, 0, numBytesRead);
                }
            }
        }
            catch( IOException e )
            {
                e.printStackTrace();
            }
            line.drain();
            line.close();
        
    }

}
